{{ sdram-video-test.spin }}
CON
  _clkmode = XTAL1 + PLL16X
  _xinfreq = 6_250_000

  QSIZE = 256

OBJ
  vid : "sdram-video-20MHz-le-propfont"

VAR
  word queue [QSIZE * 4]   ' paint queue

  long randstate
  long startline
  long mylock

PUB Main | col, i, j, k, m
  mylock := locknew         ' the lock is for competing producers into the queue
  lockclr (mylock)          ' there is only one consumer

  startline := 1
  vid.Start (QSIZE, @queue, @startline, mylock)

  randstate := CNT         ' dumb random generator for demo

  col := $FF               ' colour value
  j := 0
  k := 0

  vid.set_colours (col, col)
  repeat until j == $0200
    vid.draw_span (0, j, vid#WIDTH)  ' erase one page
    j += 1
    if (j & $7F) == 0
      col := (col+25) & $FF    ' change colour every so often
      vid.set_colours (col, 0)

  j := 0
  vid.drain_queue

  ' test pattern with random circles
  repeat
    vid.do_circle (random (500)+150, random (vid#HEIGHT), col { random(200)+1} )
    col := (col+1) &  $FF
   ' startline ++
    vid.set_colours (col, 0)
    if col & 31 == 0
      waitcnt (CNT + clkfreq)
      'vid.set_colours (0, 0)
      'vid.fill_rect (0, 1, 799, 480)
      repeat k from 0 to 14
        repeat i from 0 to 49
          vid.set_colours (col+k+i, 0)
          vid.draw_glyph (i<<4, 1+(k<<5), m & $FF)
          m ++
      waitcnt (CNT + clkfreq)
    if col & 3 == 0
      'vid.fill_rect (random (400), random (200), 401+random (400), 201+random (200))
      vid.border_rect (random (400), random (200), 401+random (400), 201+random (200))
      'vid.draw_rect (random (400), random (200), 401+random (400), 201+random (200))


PRI  sine (i)
  i |= 1
  if i < 0
    return -sine(-i)
  if i => $40000000
    return sine ($80000000-i)
  return word [$E000][(i>>19) & $7FF] ~> 8


PRI  random (n)
  randstate := randstate * 537 + $43853988       ' totally guessed linear congruential parameters(!)
  return (randstate >> 10) // n


{{
////////////////////////////////////////////////////////////////////////////////////////////
//                                TERMS OF USE: MIT License
////////////////////////////////////////////////////////////////////////////////////////////
// Permission is hereby granted, free of charge, to any person obtaining a copy of this
// software and associated documentation files (the "Software"), to deal in the Software
// without restriction, including without limitation the rights to use, copy, modify, merge,
// publish, distribute, sublicense, and/or sell copies of the Software, and to permit
// persons to whom the Software is furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in all copies or
// substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
// INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
// PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE
// FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
// OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
// DEALINGS IN THE SOFTWARE.
////////////////////////////////////////////////////////////////////////////////////////////
}}
